<html>
<head>
<title>OgreZip.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreZip.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreZip_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Zip_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Zip_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreArchive_8h.html">OgreArchive.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreArchiveFactory_8h.html">OgreArchiveFactory.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward declaration for zziplib to avoid header file dependency.</span>
<a name="l00037"></a><a class="code" href="OgreZip_8h.html#a8cee87e0d5584ff66b56196eec9758c4">00037</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>zzip_dir     <a class="code" href="OgreZip_8h.html#a8cee87e0d5584ff66b56196eec9758c4">ZZIP_DIR</a>;
<a name="l00038"></a><a class="code" href="OgreZip_8h.html#a83aee2653632d452e58ac776fde409ea">00038</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>zzip_file    <a class="code" href="OgreZip_8h.html#a83aee2653632d452e58ac776fde409ea">ZZIP_FILE</a>;
<a name="l00039"></a><a class="code" href="OgreZip_8h.html#aca6c71c876a785a50b45f36e29b27c09">00039</a> <span class="keyword">typedef</span> <span class="keyword">union </span>_zzip_plugin_io <a class="code" href="OgreZip_8h.html#aca6c71c876a785a50b45f36e29b27c09">zzip_plugin_io_handlers</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Ogre {
<a name="l00042"></a>00042 
<a name="l00055"></a><a class="code" href="classOgre_1_1ZipArchive.html">00055</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source archive...">ZipArchive</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a> 
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057     <span class="keyword">protected</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1ZipArchive.html#ac95bbd525401e829a38652abdb255003">00059</a>         <a class="code" href="OgreZip_8h.html#a8cee87e0d5584ff66b56196eec9758c4">ZZIP_DIR</a>* <a class="code" href="classOgre_1_1ZipArchive.html#ac95bbd525401e829a38652abdb255003" title="Handle to root zip file.">mZzipDir</a>;
<a name="l00061"></a>00061         <span class="keywordtype">void</span> checkZzipError(<span class="keywordtype">int</span> zzipError, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; operation) <span class="keyword">const</span>;
<a name="l00063"></a><a class="code" href="classOgre_1_1ZipArchive.html#a33516e5d5f732b34a58413df6b2d5a06">00063</a>         <a class="code" href="group__Resources.html#ga80f17ac4d148a831fe015742d56727f9">FileInfoList</a> <a class="code" href="classOgre_1_1ZipArchive.html#a33516e5d5f732b34a58413df6b2d5a06" title="File list (since zziplib seems to only allow scanning of dir tree once)">mFileList</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1ZipArchive.html#ae4948ddce8c9555845de868fd718f917">00065</a>         <a class="code" href="OgreZip_8h.html#aca6c71c876a785a50b45f36e29b27c09">zzip_plugin_io_handlers</a>* <a class="code" href="classOgre_1_1ZipArchive.html#ae4948ddce8c9555845de868fd718f917" title="A pointer to file io alternative implementation.">mPluginIo</a>;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00068"></a>00068     <span class="keyword">public</span>:
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source archive...">ZipArchive</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; archType, <a class="code" href="OgreZip_8h.html#aca6c71c876a785a50b45f36e29b27c09">zzip_plugin_io_handlers</a>* pluginIo = NULL);
<a name="l00070"></a>00070         ~<a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source archive...">ZipArchive</a>();
<a name="l00072"></a><a class="code" href="classOgre_1_1ZipArchive.html#a4bb33f4e21a4ca69049eae7c6fc5b6e5">00072</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ZipArchive.html#a4bb33f4e21a4ca69049eae7c6fc5b6e5">isCaseSensitive</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00073"></a>00073 
<a name="l00075"></a>00075         <span class="keywordtype">void</span> load();
<a name="l00077"></a>00077         <span class="keywordtype">void</span> unload();
<a name="l00078"></a>00078 
<a name="l00080"></a>00080         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> open(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <span class="keywordtype">bool</span> readOnly = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> create(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) <span class="keyword">const</span>;
<a name="l00084"></a>00084 
<a name="l00086"></a>00086         <span class="keywordtype">void</span> <span class="keyword">remove</span>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00089"></a>00089         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> <a class="code" href="structOgre_1_1list.html">list</a>(<span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00090"></a>00090 
<a name="l00092"></a>00092         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">FileInfoListPtr</a> listFileInfo(<span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00093"></a>00093 
<a name="l00095"></a>00095         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> find(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>,
<a name="l00096"></a>00096             <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00097"></a>00097 
<a name="l00099"></a>00099         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">FileInfoListPtr</a> findFileInfo(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>,
<a name="l00100"></a>00100             <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00101"></a>00101 
<a name="l00103"></a>00103         <span class="keywordtype">bool</span> exists(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00104"></a>00104 
<a name="l00106"></a>00106         time_t getModifiedTime(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00107"></a>00107     };
<a name="l00108"></a>00108 
<a name="l00110"></a><a class="code" href="classOgre_1_1ZipArchiveFactory.html">00110</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ZipArchiveFactory.html" title="Specialisation of ArchiveFactory for Zip files.">ZipArchiveFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ArchiveFactory.html" title="Abstract factory class, archive codec plugins can register concrete subclasses of this...">ArchiveFactory</a>
<a name="l00111"></a>00111     {
<a name="l00112"></a>00112     <span class="keyword">public</span>:
<a name="l00113"></a><a class="code" href="classOgre_1_1ZipArchiveFactory.html#ab1151aa6471ec8ff2be0f6555be51c8a">00113</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ZipArchiveFactory.html#ab1151aa6471ec8ff2be0f6555be51c8a">~ZipArchiveFactory</a>() {}
<a name="l00115"></a>00115         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00117"></a><a class="code" href="classOgre_1_1ZipArchiveFactory.html#a6cb4d739190da43608bcf7139c103e75">00117</a>         <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a> *createInstance( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name ) 
<a name="l00118"></a>00118         {
<a name="l00119"></a>00119             <span class="keywordflow">return</span> <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source archive...">ZipArchive</a>(name, <span class="stringliteral">&quot;Zip&quot;</span>);
<a name="l00120"></a>00120         }
<a name="l00122"></a><a class="code" href="classOgre_1_1ZipArchiveFactory.html#a78ccbf84f63fd51ef681bbbeacb383bd">00122</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ZipArchiveFactory.html#a78ccbf84f63fd51ef681bbbeacb383bd">destroyInstance</a>( <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* arch) { <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> arch; }
<a name="l00123"></a>00123     };
<a name="l00124"></a>00124 
<a name="l00126"></a><a class="code" href="classOgre_1_1EmbeddedZipArchiveFactory.html">00126</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1EmbeddedZipArchiveFactory.html" title="Specialisation of ZipArchiveFactory for embedded Zip files.">EmbeddedZipArchiveFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ZipArchiveFactory.html" title="Specialisation of ArchiveFactory for Zip files.">ZipArchiveFactory</a>
<a name="l00127"></a>00127     {
<a name="l00128"></a>00128     <span class="keyword">protected</span>:
<a name="l00130"></a><a class="code" href="classOgre_1_1EmbeddedZipArchiveFactory.html#a4b0e034d491b4c34d7db90b3d3a8ea15">00130</a>         <span class="keyword">static</span> <a class="code" href="OgreZip_8h.html#aca6c71c876a785a50b45f36e29b27c09">zzip_plugin_io_handlers</a>* <a class="code" href="classOgre_1_1EmbeddedZipArchiveFactory.html#a4b0e034d491b4c34d7db90b3d3a8ea15" title="A static pointer to file io alternative implementation for the embedded files.">mPluginIo</a>; 
<a name="l00131"></a>00131     <span class="keyword">public</span>:
<a name="l00132"></a>00132         <a class="code" href="classOgre_1_1EmbeddedZipArchiveFactory.html" title="Specialisation of ZipArchiveFactory for embedded Zip files.">EmbeddedZipArchiveFactory</a>();
<a name="l00133"></a>00133         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1EmbeddedZipArchiveFactory.html" title="Specialisation of ZipArchiveFactory for embedded Zip files.">EmbeddedZipArchiveFactory</a>();
<a name="l00135"></a>00135         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00137"></a><a class="code" href="classOgre_1_1EmbeddedZipArchiveFactory.html#a6f6f93ac889b55a18172755d8ce05050">00137</a>         <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a> *createInstance( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name ) 
<a name="l00138"></a>00138         {
<a name="l00139"></a>00139             <a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source archive...">ZipArchive</a> * resZipArchive = <a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> <a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source archive...">ZipArchive</a>(name, <span class="stringliteral">&quot;EmbeddedZip&quot;</span>, mPluginIo);
<a name="l00140"></a>00140             <span class="keywordflow">return</span> resZipArchive;
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142         
<a name="l00149"></a><a class="code" href="classOgre_1_1EmbeddedZipArchiveFactory.html#a7510e7004e581540dc34f39cda20ac46">00149</a>         <span class="keyword">typedef</span> bool (*DecryptEmbeddedZipFileFunc)(<span class="keywordtype">size_t</span> pos, <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> len);
<a name="l00150"></a>00150 
<a name="l00152"></a>00152         <span class="keyword">static</span> <span class="keywordtype">void</span> addEmbbeddedFile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> * fileData, 
<a name="l00153"></a>00153                         <span class="keywordtype">size_t</span> fileSize, DecryptEmbeddedZipFileFunc decryptFunc);
<a name="l00154"></a>00154 
<a name="l00156"></a>00156         <span class="keyword">static</span> <span class="keywordtype">void</span> removeEmbbeddedFile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     };
<a name="l00159"></a>00159 
<a name="l00161"></a><a class="code" href="classOgre_1_1ZipDataStream.html">00161</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ZipDataStream.html" title="Specialisation of DataStream to handle streaming data from zip archives.">ZipDataStream</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163     <span class="keyword">protected</span>:
<a name="l00164"></a><a class="code" href="classOgre_1_1ZipDataStream.html#a0114a4510ef5b5f5fc2e4767265c54e1">00164</a>         <a class="code" href="OgreZip_8h.html#a83aee2653632d452e58ac776fde409ea">ZZIP_FILE</a>* <a class="code" href="classOgre_1_1ZipDataStream.html#a0114a4510ef5b5f5fc2e4767265c54e1">mZzipFile</a>;
<a name="l00166"></a><a class="code" href="classOgre_1_1ZipDataStream.html#ade3e64c8373a3e5daf651674c9142114">00166</a>         <a class="code" href="classOgre_1_1StaticCache.html">StaticCache&lt;2 * OGRE_STREAM_TEMP_SIZE&gt;</a> <a class="code" href="classOgre_1_1ZipDataStream.html#ade3e64c8373a3e5daf651674c9142114" title="We need caching because sometimes serializers step back in data stream and zziplib behaves slow...">mCache</a>;
<a name="l00167"></a>00167     <span class="keyword">public</span>:
<a name="l00169"></a>00169         <a class="code" href="classOgre_1_1ZipDataStream.html" title="Specialisation of DataStream to handle streaming data from zip archives.">ZipDataStream</a>(<a class="code" href="OgreZip_8h.html#a83aee2653632d452e58ac776fde409ea">ZZIP_FILE</a>* zzipFile, <span class="keywordtype">size_t</span> uncompressedSize);
<a name="l00171"></a>00171         <a class="code" href="classOgre_1_1ZipDataStream.html" title="Specialisation of DataStream to handle streaming data from zip archives.">ZipDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="OgreZip_8h.html#a83aee2653632d452e58ac776fde409ea">ZZIP_FILE</a>* zzipFile, <span class="keywordtype">size_t</span> uncompressedSize);
<a name="l00172"></a>00172         ~<a class="code" href="classOgre_1_1ZipDataStream.html" title="Specialisation of DataStream to handle streaming data from zip archives.">ZipDataStream</a>();
<a name="l00174"></a>00174         <span class="keywordtype">size_t</span> read(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00176"></a>00176         <span class="keywordtype">size_t</span> write(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00178"></a>00178         <span class="keywordtype">void</span> skip(<span class="keywordtype">long</span> count);
<a name="l00180"></a>00180         <span class="keywordtype">void</span> seek( <span class="keywordtype">size_t</span> pos );
<a name="l00182"></a>00182         <span class="keywordtype">size_t</span> tell(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00184"></a>00184         <span class="keywordtype">bool</span> eof(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00186"></a>00186         <span class="keywordtype">void</span> close(<span class="keywordtype">void</span>);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189     };
<a name="l00190"></a>00190 
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
